"use strict";

Liferay.Loader.define("content-dashboard-web$victory-vendor@36.7.0/lib-vendor/d3-scale/src/sequential", ['module', 'exports', 'require', '../../../lib-vendor/d3-interpolate/src/index', './continuous', './init', './linear', './log', './symlog', './pow'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.copy = copy;
    exports.default = sequential;
    exports.sequentialLog = sequentialLog;
    exports.sequentialPow = sequentialPow;
    exports.sequentialSqrt = sequentialSqrt;
    exports.sequentialSymlog = sequentialSymlog;

    var _index = require("../../../lib-vendor/d3-interpolate/src/index");

    var _continuous = require("./continuous");

    var _init = require("./init");

    var _linear = require("./linear");

    var _log = require("./log");

    var _symlog = require("./symlog");

    var _pow = require("./pow");

    function transformer() {
      var x0 = 0,
          x1 = 1,
          t0,
          t1,
          k10,
          transform,
          interpolator = _continuous.identity,
          clamp = false,
          unknown;

      function scale(x) {
        return x == null || isNaN(x = +x) ? unknown : interpolator(k10 === 0 ? 0.5 : (x = (transform(x) - t0) * k10, clamp ? Math.max(0, Math.min(1, x)) : x));
      }

      scale.domain = function (_) {
        return arguments.length ? ([x0, x1] = _, t0 = transform(x0 = +x0), t1 = transform(x1 = +x1), k10 = t0 === t1 ? 0 : 1 / (t1 - t0), scale) : [x0, x1];
      };

      scale.clamp = function (_) {
        return arguments.length ? (clamp = !!_, scale) : clamp;
      };

      scale.interpolator = function (_) {
        return arguments.length ? (interpolator = _, scale) : interpolator;
      };

      function range(interpolate) {
        return function (_) {
          var r0, r1;
          return arguments.length ? ([r0, r1] = _, interpolator = interpolate(r0, r1), scale) : [interpolator(0), interpolator(1)];
        };
      }

      scale.range = range(_index.interpolate);
      scale.rangeRound = range(_index.interpolateRound);

      scale.unknown = function (_) {
        return arguments.length ? (unknown = _, scale) : unknown;
      };

      return function (t) {
        transform = t, t0 = t(x0), t1 = t(x1), k10 = t0 === t1 ? 0 : 1 / (t1 - t0);
        return scale;
      };
    }

    function copy(source, target) {
      return target.domain(source.domain()).interpolator(source.interpolator()).clamp(source.clamp()).unknown(source.unknown());
    }

    function sequential() {
      var scale = (0, _linear.linearish)(transformer()(_continuous.identity));

      scale.copy = function () {
        return copy(scale, sequential());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function sequentialLog() {
      var scale = (0, _log.loggish)(transformer()).domain([1, 10]);

      scale.copy = function () {
        return copy(scale, sequentialLog()).base(scale.base());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function sequentialSymlog() {
      var scale = (0, _symlog.symlogish)(transformer());

      scale.copy = function () {
        return copy(scale, sequentialSymlog()).constant(scale.constant());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function sequentialPow() {
      var scale = (0, _pow.powish)(transformer());

      scale.copy = function () {
        return copy(scale, sequentialPow()).exponent(scale.exponent());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function sequentialSqrt() {
      return sequentialPow.apply(null, arguments).exponent(0.5);
    }
  }
});
//# sourceMappingURL=sequential.js.map